import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.*;
import java.awt.geom.Point2D;
import java.io.*;

public class MouseListener extends MouseAdapter {
	private Matrix matrix;
    private ElectricalElement selectedElement;
    private MatrixElement sel_elem;
    private Point pos, pos_past;
    private boolean ocuped;
    
    //constructor
    public MouseListener(Matrix m){
        matrix = m;//variable del entorno
        selectedElement = null;
        sel_elem = null;
        pos = new Point(0,0);
        pos_past = new Point(0,0);
        ocuped = false;
    }

    public void mouseClicked(MouseEvent e){
    	pos = e.getPoint();
        System.out.println(pos);
   		//maquina de estados para agregar o seleccionar
   		//si se selecciona, implementar desplazamiento por el glass
   		//sino, mover elemento de casilla en la matrix
   		pos = matrix.getShownMatrixIndex(pos);
        System.out.println(pos+"\t"+matrix.getCellShownSize());

        int wh = (int) matrix.getCellShownSize();
        int tlx = (int) pos.getX()*wh;
        int tly = (int) pos.getY()*wh;

		ocuped = (matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].getMyElement() != null);

    	if(sel_elem == null){
    		if(ocuped){
                pos_past = new Point((int)pos.getX(), (int)pos.getY());
    			//selectedElement = (matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].getMyElement());
                sel_elem = matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()];
                sel_elem.getMyElement().setSelected(true);
    			//selectedElement.setSelected(true);
    			matrix.getView().repaint();
    		}
            else{
                pos_past = new Point(0,0);
                sel_elem = null;
            }
    	}
        else if(sel_elem.getMyElement()==null){
            if(ocuped){
                pos_past = new Point((int)pos.getX(), (int)pos.getY());
                //selectedElement = (matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].getMyElement());
                sel_elem = matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()];
                sel_elem.getMyElement().setSelected(true);
                //selectedElement.setSelected(true);
                matrix.getView().repaint();
            }
            else{
                pos_past = new Point(0,0);
                sel_elem = null;
            }
        }
    	/*else{
            if(!ocuped){
                if(selectedElement instanceof Capacitor){
                    Capacitor c = (Capacitor) selectedElement;
                    matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(c.clone());
                    c.resize(tlx, tly, wh);
                }
                else if(selectedElement instanceof Inductor){
                    Inductor i = (Inductor) selectedElement;
                    matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(i.clone());
                    i.resize(tlx, tly, wh);
                }
                else if(selectedElement instanceof Resistor){
                    Resistor r = (Resistor) selectedElement;
                    matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(r.clone());
                    r.resize(tlx, tly, wh);
                }
                else if(selectedElement instanceof VoltageSource){
                    VoltageSource v = (VoltageSource) selectedElement;
                    matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(v.clone());
                    v.resize(tlx, tly, wh);
                }
                else if(selectedElement instanceof Wire){
                    Wire w = (Wire) selectedElement;
                    matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(w.clone());
                    w.resize(tlx, tly, wh);
                }
    	
    			selectedElement.setSelected(false);
    			selectedElement = null;
    			matrix.getView().repaint();
    		}
    	}*/
        else{
            if(!ocuped){
                matrix.addElement(sel_elem, (int)pos.getX(), (int)pos.getY());
                sel_elem.getMyElement().resize(tlx, tly, wh);
                sel_elem.getMyElement().setSelected(false);
                matrix.addElement(new MatrixElement(), (int)pos_past.getX(), (int)pos_past.getY());
                pos_past = new Point(0,0);
                sel_elem = null;
            }
            else{
                sel_elem.getMyElement().setOverWrite(true);
                matrix.getView().repaint();
            }
        }
    }

/*    public void mouseMoved(MouseEvent e){
    	//verificar si se tiene un elemento seleccionado
    	//si, entonces implementar movimiento por el glass
    	//sino, no implementar

    }*/

    //////////////////////////////////////////////////////////////////
    // agregar metodo en la clase matrix para convertir el pixel 	//
    // de el screen a una casilla de la matrixshown.				//
    // agregar metodo que convierta una casilla de la matrixshow a  //
    // una casilla de la matrix completa. Check						//
    //////////////////////////////////////////////////////////////////
}